Index: branches/2924_DotNetCoreMigration/HeuristicLab 3.3.sln
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab 3.3.sln	(revision 16857)
+++ branches/2924_DotNetCoreMigration/HeuristicLab 3.3.sln	(revision 16859)
@@ -1,6 +1,6 @@
 ﻿
 Microsoft Visual Studio Solution File, Format Version 12.00
-# Visual Studio 15
-VisualStudioVersion = 15.0.26730.16
+# Visual Studio Version 16
+VisualStudioVersion = 16.0.28803.202
 MinimumVisualStudioVersion = 10.0.40219.1
 Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Solution Items", "Solution Items", "{96396439-A764-4022-A8D2-BE021449B8D1}"
@@ -164,5 +164,5 @@
 	EndProjectSection
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PluginInfrastructure-3.3", "HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj", "{94186A6A-5176-4402-AE83-886557B53CCA}"
+Project("{9A19103F-16F7-4668-BE54-9A1E7A4F7556}") = "HeuristicLab.PluginInfrastructure-3.3", "HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj", "{94186A6A-5176-4402-AE83-886557B53CCA}"
 EndProject
 Project("{9A19103F-16F7-4668-BE54-9A1E7A4F7556}") = "HeuristicLab.Persistence-3.3", "HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj", "{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}"
@@ -302,5 +302,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Hive-3.3", "HeuristicLab.Hive\3.3\HeuristicLab.Hive-3.3.csproj", "{F98A1740-9AC9-4D36-A582-6A2D0D06978D}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive-3.3", "HeuristicLab.Clients.Hive\3.3\HeuristicLab.Clients.Hive-3.3.csproj", "{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}"
+Project("{9A19103F-16F7-4668-BE54-9A1E7A4F7556}") = "HeuristicLab.Clients.Hive-3.3", "HeuristicLab.Clients.Hive\3.3\HeuristicLab.Clients.Hive-3.3.csproj", "{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Views-3.3", "HeuristicLab.Clients.Hive.Views\3.3\HeuristicLab.Clients.Hive.Views-3.3.csproj", "{E1D6C801-892A-406A-B606-F158E36DD3C3}"
@@ -465,5 +465,7 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PluginInfrastructure.UI-4.0", "HeuristicLab.PluginInfrastructure.UI\HeuristicLab.PluginInfrastructure.UI-4.0.csproj", "{7AF3C7B6-8BA5-44F3-8D5B-2BF7A23CF12D}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PasswordDialog", "HeuristicLab.PasswordDialog\3.4\HeuristicLab.PasswordDialog-3.4.csproj", "{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}"
+Project("{9A19103F-16F7-4668-BE54-9A1E7A4F7556}") = "HeuristicLab.PluginInfrastructure.Runner-3.4", "HeuristicLab.PluginInfrastructure.Runner\3.4\HeuristicLab.PluginInfrastructure.Runner-3.4.csproj", "{CA1A1E78-929C-4017-B4B3-BFB73A457461}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.PasswordDialog-3.4", "HeuristicLab.PasswordDialog\3.4\HeuristicLab.PasswordDialog-3.4.csproj", "{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}"
 EndProject
 Global
@@ -491,14 +493,14 @@
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x64.ActiveCfg = Debug|x64
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x64.Build.0 = Debug|x64
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x86.ActiveCfg = Debug|x86
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x86.Build.0 = Debug|x86
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x64.Build.0 = Debug|Any CPU
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Debug|x86.Build.0 = Debug|Any CPU
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|Any CPU.Build.0 = Release|Any CPU
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x64.ActiveCfg = Release|x64
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x64.Build.0 = Release|x64
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.ActiveCfg = Release|x86
-		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.Build.0 = Release|x86
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x64.ActiveCfg = Release|Any CPU
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x64.Build.0 = Release|Any CPU
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.ActiveCfg = Release|Any CPU
+		{94186A6A-5176-4402-AE83-886557B53CCA}.Release|x86.Build.0 = Release|Any CPU
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1031,14 +1033,14 @@
 		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x64.ActiveCfg = Debug|x64
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x64.Build.0 = Debug|x64
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x86.ActiveCfg = Debug|x86
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x86.Build.0 = Debug|x86
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x64.Build.0 = Debug|Any CPU
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Debug|x86.Build.0 = Debug|Any CPU
 		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|Any CPU.Build.0 = Release|Any CPU
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x64.ActiveCfg = Release|x64
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x64.Build.0 = Release|x64
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x86.ActiveCfg = Release|x86
-		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x86.Build.0 = Release|x86
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x64.ActiveCfg = Release|Any CPU
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x64.Build.0 = Release|Any CPU
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x86.ActiveCfg = Release|Any CPU
+		{730A9104-D4D1-4360-966B-E49B7571DDA3}.Release|x86.Build.0 = Release|Any CPU
 		{315BDA09-3F4F-49B3-9790-B37CFC1C5750}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{315BDA09-3F4F-49B3-9790-B37CFC1C5750}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -1319,14 +1321,14 @@
 		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x64.ActiveCfg = Debug|x64
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x64.Build.0 = Debug|x64
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x86.ActiveCfg = Debug|x86
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x86.Build.0 = Debug|x86
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x64.Build.0 = Debug|Any CPU
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Debug|x86.Build.0 = Debug|Any CPU
 		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|Any CPU.Build.0 = Release|Any CPU
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x64.ActiveCfg = Release|x64
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x64.Build.0 = Release|x64
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x86.ActiveCfg = Release|x86
-		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x86.Build.0 = Release|x86
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x64.ActiveCfg = Release|Any CPU
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x64.Build.0 = Release|Any CPU
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x86.ActiveCfg = Release|Any CPU
+		{B5EF1E5A-9F3D-40B9-B4B0-30AADF2E2CEB}.Release|x86.Build.0 = Release|Any CPU
 		{E1D6C801-892A-406A-B606-F158E36DD3C3}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{E1D6C801-892A-406A-B606-F158E36DD3C3}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -2261,4 +2263,28 @@
 		{7AF3C7B6-8BA5-44F3-8D5B-2BF7A23CF12D}.Release|x64.ActiveCfg = Release|Any CPU
 		{7AF3C7B6-8BA5-44F3-8D5B-2BF7A23CF12D}.Release|x86.ActiveCfg = Release|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Debug|x64.Build.0 = Debug|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Debug|x86.Build.0 = Debug|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Release|Any CPU.Build.0 = Release|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Release|x64.ActiveCfg = Release|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Release|x64.Build.0 = Release|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Release|x86.ActiveCfg = Release|Any CPU
+		{CA1A1E78-929C-4017-B4B3-BFB73A457461}.Release|x86.Build.0 = Release|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Debug|x64.Build.0 = Debug|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Debug|x86.Build.0 = Debug|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Release|Any CPU.Build.0 = Release|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Release|x64.ActiveCfg = Release|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Release|x64.Build.0 = Release|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Release|x86.ActiveCfg = Release|Any CPU
+		{632E2C03-FA6F-4540-8AF0-6B4D60F99F26}.Release|x86.Build.0 = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/2924_DotNetCoreMigration/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 16857)
+++ branches/2924_DotNetCoreMigration/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 16859)
@@ -331,5 +331,5 @@
     <ProjectReference Include="..\..\HeuristicLab.PasswordDialog\3.4\HeuristicLab.PasswordDialog-3.4.csproj">
       <Project>{632e2c03-fa6f-4540-8af0-6b4d60f99f26}</Project>
-      <Name>HeuristicLab.PasswordDialog</Name>
+      <Name>HeuristicLab.PasswordDialog-3.4</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
Index: branches/2924_DotNetCoreMigration/HeuristicLab.PasswordDialog/3.4/PasswordDialog.Designer.cs
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab.PasswordDialog/3.4/PasswordDialog.Designer.cs	(revision 16857)
+++ branches/2924_DotNetCoreMigration/HeuristicLab.PasswordDialog/3.4/PasswordDialog.Designer.cs	(revision 16859)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.Clients.Common {
+namespace HeuristicLab.PasswordDialog {
   partial class PasswordDialog {
     /// <summary>
Index: branches/2924_DotNetCoreMigration/HeuristicLab.PasswordDialog/3.4/PasswordDialog.cs
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab.PasswordDialog/3.4/PasswordDialog.cs	(revision 16857)
+++ branches/2924_DotNetCoreMigration/HeuristicLab.PasswordDialog/3.4/PasswordDialog.cs	(revision 16859)
@@ -22,7 +22,8 @@
 using System;
 using System.Windows.Forms;
+using HeuristicLab.Clients.Common;
 using HeuristicLab.Clients.Common.Properties;
 
-namespace HeuristicLab.Clients.Common {
+namespace HeuristicLab.PasswordDialog {
   public partial class PasswordDialog : Form {
     public PasswordDialog() {
Index: branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/ActivatorContext.cs
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/ActivatorContext.cs	(revision 16859)
+++ branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/ActivatorContext.cs	(revision 16859)
@@ -0,0 +1,18 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.PluginInfrastructure.Runner {
+
+  public class ActivatorContext : IActivatorContext {
+
+    private IPluginLoader loader;
+    internal ActivatorContext(IPluginLoader pluginLoader) {
+      loader = pluginLoader;
+    }
+
+    public IList<IPlugin> Plugins => loader.Plugins;
+    public IList<IApplication> Applications => loader.Applications;
+  }
+}
Index: branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/AssemblyLoader.cs
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/AssemblyLoader.cs	(revision 16859)
+++ branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/AssemblyLoader.cs	(revision 16859)
@@ -0,0 +1,192 @@
+﻿using System;
+using System.Linq;
+using System.Collections.Generic;
+using System.IO;
+using System.Reflection;
+using System.Runtime.Loader;
+using System.Runtime.Versioning;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.PluginInfrastructure.Runner {
+
+  public class AssemblyLoader : IAssemblyLoader {
+    private class AssemblyNameComparer : IEqualityComparer<AssemblyName> {
+      private object concatProps(AssemblyName name) => name.FullName + name.Version.ToString();
+      public bool Equals(AssemblyName lhs, AssemblyName rhs) => concatProps(lhs).Equals(concatProps(rhs));
+      public int GetHashCode(AssemblyName obj) => concatProps(obj).GetHashCode();
+    }
+
+    //https://github.com/dotnet/coreclr/blob/master/Documentation/design-docs/assemblyloadcontext.md
+    private class ALC : AssemblyLoadContext {
+      private Dictionary<AssemblyName, Assembly> loadedAssemblies = new Dictionary<AssemblyName, Assembly>(new AssemblyNameComparer());
+      private string BasePath { get; set; }
+      public ALC(string basePath) { BasePath = basePath; }
+      protected override Assembly Load(AssemblyName assemblyName) {
+        if (loadedAssemblies.ContainsKey(assemblyName)) return loadedAssemblies[assemblyName];
+
+        string path = $"{BasePath}{Path.DirectorySeparatorChar}{assemblyName.Name}.dll";
+        Assembly asm = null;
+        if (File.Exists(path))
+          asm = Assembly.LoadFrom(path);
+        else 
+          asm = Assembly.Load(assemblyName);
+        loadedAssemblies.Add(assemblyName, asm);
+        foreach (var a in asm.GetReferencedAssemblies())
+          Load(a);
+        return asm;
+      }
+    }
+
+    private ALC alc;
+    public string BasePath { get; set; }
+    public string AssemblyPrefix { get; set; }
+
+    //public IList<Assembly> Assemblies { private set; get; } = new List<Assembly>();
+    //public IList<Type> Types { private set; get; } = new List<Type>();
+
+    private IList<Assembly> assemblies = new List<Assembly>();
+    public IEnumerable<Assembly> Assemblies => assemblies;
+
+    private IList<Type> types = new List<Type>();
+    public IEnumerable<Type> Types => types;
+
+    public AssemblyLoader() : this(Directory.GetCurrentDirectory()) { }
+    public AssemblyLoader(string basePath) {
+      this.BasePath = basePath;
+      alc = new ALC(BasePath);
+      /*
+      ScanTypesInBasePath();
+      Types = GetTypes();
+      */
+      /*
+      IEnumerable<Assembly> asms = CheckDependencies(GetLoadableAssemblies(GetAssembliesFromBasePath()));
+      LoadAssemblies(asms);
+      LoadTypes(asms);
+      */
+      //IEnumerable<Assembly> asms = GetLoadableAssemblies(GetAssembliesFromBasePath());
+      //LoadAssemblies(asms);
+      //LoadTypes(asms);
+    }
+
+    // 1.
+    private IEnumerable<string> GetAssembliesFromBasePath() {
+      return Directory.GetFiles(BasePath, $"*.dll", SearchOption.AllDirectories);
+    }
+    /*
+    // 2.
+    private IEnumerable<Assembly> GetLoadableAssemblies(IEnumerable<string> paths) {
+      IList<Assembly> assemblies = new List<Assembly>();      
+      foreach (string path in paths) {
+        try {
+          var asm = Assembly.LoadFile(path);
+          if (asm != null)
+            assemblies.Add(asm);
+          else
+            Console.WriteLine($"cannot load assembly with path={path}");
+        } catch (Exception e) {
+          Console.WriteLine($"exception occured for assembly with path={path}, type of exception={e.GetType()}");
+        }
+      }
+      
+      return assemblies;
+    }
+    
+    // 3.
+    private IEnumerable<Assembly> CheckDependencies(IEnumerable<Assembly> assemblies) {
+      IEqualityComparer<AssemblyName> comp = new AssemblyNameComparer();
+      IDictionary<AssemblyName, Assembly> dict = new Dictionary<AssemblyName, Assembly>(comp);
+
+      // fill dict
+      foreach (Assembly a in assemblies)
+        dict.Add(a.GetName(), a);
+
+      Parallel.ForEach(new List<Assembly>(dict.Values), asm => {
+        if (CheckDependencyRecursiveHelper(asm.GetName(), asm.GetReferencedAssemblies(), comp, dict))
+          lock(dict)
+            dict.Remove(asm.GetName());
+      });
+      return dict.Values;
+    }
+
+    private bool CheckDependencyRecursiveHelper(AssemblyName toCheck, IEnumerable<AssemblyName> refs, IEqualityComparer<AssemblyName> comp, IDictionary<AssemblyName, Assembly> dict) {
+      foreach(AssemblyName name in refs) {
+        if (comp.Equals(toCheck, name) || !dict.ContainsKey(name) || CheckDependencyRecursiveHelper(toCheck, dict[name].GetReferencedAssemblies(), comp, dict)) return true;
+      }
+      return false;
+    }
+    
+    // 4.
+    private void LoadAssemblies(IEnumerable<Assembly> assemblies) {
+
+      foreach (Assembly asm in assemblies) {
+        try {
+          Assemblies.Add(alc.LoadFromAssemblyName(asm.GetName()));
+        } catch(Exception e) { }
+      }
+    }
+    */
+    private void LoadTypes(IEnumerable<Assembly> assemblies) {
+      foreach (Assembly asm in assemblies) {
+        try {
+          foreach (Type t in asm.GetExportedTypes()) {
+            types.Add(t);
+          }
+        } catch (ReflectionTypeLoadException e) {
+          try {
+            foreach (Type t in e.Types) {
+              if (t != null) {
+                types.Add(t);
+              }
+            }
+          } catch (BadImageFormatException) { }
+
+        } catch (Exception e) {
+          Tracing.Logger.Error(
+            $"Exception occured while loading types of assembly {asm.FullName}! \n " +
+            $"---- Stacktrace ---- \n {e}");
+        }
+      }
+    }
+    /*
+    public Type GetType(string type) {
+      foreach (Assembly asm in Assemblies) {
+        Type t = asm.GetType(type);
+        if (t != null) return t;
+      }
+      return null;
+    }
+    */
+
+    public IEnumerable<Assembly> GetReflectionOnlyAssemblies() {
+      IList<Assembly> list = new List<Assembly>();
+      foreach (string path in GetAssembliesFromBasePath()) {
+        try {
+          var asm = Assembly.LoadFrom(path);
+          if (asm != null)
+            list.Add(asm);
+          else
+            Tracing.Logger.Error($"Unnable to load assembly with path {path}!");
+        } catch (Exception e) {
+          Tracing.Logger.Error(
+            $"Exception occured while loading assembly from path {path}! \n " +
+            $"---- Stacktrace ---- \n {e}");
+        }
+      }
+      return list;
+    }
+
+    public IEnumerable<Assembly> LoadAssemblies(IEnumerable<AssemblyName> assemblyNames) {
+      foreach (AssemblyName asm in assemblyNames) {
+        try {
+          this.assemblies.Add(alc.LoadFromAssemblyName(asm));
+        } catch (Exception e) {
+          Tracing.Logger.Error(
+            $"Exception occured while loading assembly: {asm.FullName}! \n " +
+            $"---- Stacktrace ---- \n {e}");
+        }
+      }
+      LoadTypes(this.Assemblies);
+      return this.Assemblies;
+    }
+  }
+}
Index: branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/HeuristicLab.PluginInfrastructure.Runner-3.4.csproj
===================================================================
--- branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/HeuristicLab.PluginInfrastructure.Runner-3.4.csproj	(revision 16859)
+++ branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure.Runner/3.4/HeuristicLab.PluginInfrastructure.Runner-3.4.csproj	(revision 16859)
@@ -0,0 +1,27 @@
+﻿<Project Sdk="Microsoft.NET.Sdk">
+
+  <PropertyGroup>
+    <OutputType>Exe</OutputType>
+    <TargetFramework>netcoreapp2.2</TargetFramework>
+    <RootNamespace>HeuristicLab.PluginInfrastructure.Runner</RootNamespace>
+    <AssemblyVersion>3.4.0.0</AssemblyVersion>
+    <FileVersion>3.4.0.0</FileVersion>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)'=='Debug|AnyCPU'">
+    <OutputPath>..\..\bin\</OutputPath>
+    <AppendTargetFrameworkToOutputPath>false</AppendTargetFrameworkToOutputPath>
+  </PropertyGroup>
+
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj" />
+    <ProjectReference Include="..\..\HeuristicLab.Tracing\3.3\HeuristicLab.Tracing-3.3.csproj" />
+  </ItemGroup>
+
+  <!--<Target Name="PostBuild" AfterTargets="PostBuildEvent" Condition="'$(OS)'=='Windows_NT'">
+    <Exec Command="docker build -t dockerrunner -f $(SolutionDir)HeuristicLab.PluginInfrastructure\3.3\Dockerfile $(SolutionDir)" />
+  </Target>-->
+
+</Project>
